(function ($) {
    Drupal.behaviors.imageCaptchaIndicator = {
        attach: function (context) {
            var solution;
            var code_length = Drupal.settings.image_captcha_code_length;

            $('#edit-captcha-response', context).keyup(function () {
                var captcha_code = $(this).val().toLowerCase();
                $('.image-captcha-indicator-error').remove();
                $('.image-captcha-indicator-success').remove();

                if(captcha_code.length <= parseInt(code_length/2)){
                    return;
                }

                if(!solution){
                    var $form = $(this).parents('form');
                    // Send post query for getting new captcha data.
                    var date = new Date();
                    var url = 'captcha/indicator/' + $form.attr('id').replace('-','_') +'?' + date.getTime();
                    $.get(
                        url,
                        {},
                        function (response) {
                            if(response.status == 1) {
                                solution = response.data['solution'].toLowerCase();
                            }
                            else {
                                alert(response.message);
                            }
                        },
                        'json'
                    );
                }
                if(captcha_code.length != code_length || captcha_code != solution ){
                    $(this).after('<span class="image-captcha-indicator-error" style="color:transparent;background-repeat:no-repeat;background-image: url('+ Drupal.settings.basePath +'/misc/watchdog-error.png)">error</span>')
                }else if(captcha_code == solution){
                    $(this).after('<span class="image-captcha-indicator-success" style="color:transparent;background-repeat:no-repeat;background-image: url('+ Drupal.settings.basePath +'/misc/watchdog-ok.png)">success</span>');
                }
            });
        }
    };
})(jQuery);
